import type { MongoDBOIDCLogEventsMap, OIDCCallbackParams, IdPServerResponse, TypedEventEmitter } from './types';
import { TokenSet } from 'openid-client';
import type { MongoDBOIDCPlugin, MongoDBOIDCPluginOptions } from './api';
/** @internal Exported for testing only */
export declare function automaticRefreshTimeoutMS(tokenSet: Pick<TokenSet, 'refresh_token' | 'expires_in'>): number | undefined;
/** @internal */
export declare class MongoDBOIDCPluginImpl implements MongoDBOIDCPlugin {
    private readonly options;
    readonly logger: TypedEventEmitter<MongoDBOIDCLogEventsMap>;
    private readonly mapIdpToAuthState;
    readonly mongoClientOptions: MongoDBOIDCPlugin['mongoClientOptions'];
    private readonly timers;
    private destroyed;
    constructor(options: Readonly<MongoDBOIDCPluginOptions>);
    private _deserialize;
    private _serialize;
    serialize(): Promise<string>;
    private getAllowedFlows;
    private getAuthState;
    private getSupportedDefaultScopes;
    private getIssuerClass;
    private getOIDCClient;
    private openBrowser;
    private notifyDeviceFlow;
    private updateStateWithTokenSet;
    static readonly defaultRedirectURI = "http://localhost:27097/redirect";
    private authorizationCodeFlow;
    private deviceAuthorizationFlow;
    private initiateAuthAttempt;
    requestToken(params: OIDCCallbackParams): Promise<IdPServerResponse>;
    destroy(): Promise<void>;
}
//# sourceMappingURL=plugin.d.ts.map