export interface CliOptions {
    connectionSpecifier?: string;
    fileNames?: string[];
    apiDeprecationErrors?: boolean;
    apiStrict?: boolean;
    apiVersion?: string;
    authenticationDatabase?: string;
    authenticationMechanism?: string;
    awsAccessKeyId?: string;
    awsIamSessionToken?: string;
    awsSecretAccessKey?: string;
    awsSessionToken?: string;
    csfleLibraryPath?: string;
    cryptSharedLibPath?: string;
    db?: string;
    eval?: string[];
    exposeAsyncRewriter?: boolean;
    gssapiServiceName?: string;
    sspiHostnameCanonicalization?: string;
    sspiRealmOverride?: string;
    help?: boolean;
    host?: string;
    ipv6?: boolean;
    jsContext?: 'repl' | 'plain-vm' | 'auto';
    json?: boolean | 'canonical' | 'relaxed';
    keyVaultNamespace?: string;
    kmsURL?: string;
    nodb?: boolean;
    norc?: boolean;
    password?: string;
    port?: string;
    quiet?: boolean;
    retryWrites?: boolean;
    shell?: boolean;
    tls?: boolean;
    tlsAllowInvalidCertificates?: boolean;
    tlsAllowInvalidHostnames?: boolean;
    tlsCAFile?: string;
    tlsCertificateKeyFile?: string;
    tlsCertificateKeyFilePassword?: string;
    tlsCertificateSelector?: string;
    tlsCRLFile?: string;
    tlsDisabledProtocols?: boolean;
    tlsFIPSMode?: boolean;
    username?: string;
    verbose?: boolean;
    version?: boolean;
    oidcFlows?: string;
    oidcRedirectUri?: string;
    oidcTrustedEndpoint?: boolean;
    oidcIdTokenAsAccessToken?: boolean;
    oidcDumpTokens?: boolean | 'redacted' | 'include-secrets';
    browser?: string | false;
}
