"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.redactSensitiveData = exports.changeHistory = exports.HIDDEN_COMMANDS = void 0;
const mongodb_redact_1 = __importDefault(require("mongodb-redact"));
exports.redactSensitiveData = mongodb_redact_1.default;
exports.HIDDEN_COMMANDS = String.raw `\b(createUser|auth|updateUser|changeUserPassword|connect|Mongo)\b`;
function changeHistory(history, redact) {
    if (history.length === 0)
        return;
    const hiddenCommands = new RegExp(exports.HIDDEN_COMMANDS, 'g');
    if (hiddenCommands.test(history[0])) {
        history.shift();
    }
    else if (redact === 'redact-sensitive-data') {
        history[0] = (0, mongodb_redact_1.default)(history[0]);
    }
}
exports.changeHistory = changeHistory;
//# sourceMappingURL=history.js.map