import type { ConnectionString } from 'mongodb-connection-string-url';
export type ConnectionExtraInfo = {
    is_atlas?: boolean;
    server_version?: string;
    server_os?: string;
    server_arch?: string;
    is_enterprise?: boolean;
    auth_type?: string;
    is_data_federation?: boolean;
    is_stream?: boolean;
    dl_version?: string;
    atlas_version?: string;
    is_genuine?: boolean;
    non_genuine_server_name?: string;
    node_version?: string;
    uri: string;
    is_local_atlas?: boolean;
} & HostInformation;
export type HostInformation = {
    is_localhost?: boolean;
    is_atlas_url?: boolean;
    is_do_url?: boolean;
};
export default function getConnectExtraInfo({ connectionString, buildInfo, atlasVersion, resolvedHostname, isLocalAtlas, }: {
    connectionString?: ConnectionString;
    buildInfo: any;
    atlasVersion: any;
    resolvedHostname?: string;
    isLocalAtlas: boolean;
}): ConnectionExtraInfo;
