import { ShellApiWithMongoClass } from './decorators';
import type Mongo from './mongo';
import type { Document, ServiceProviderFindCursor, ServiceProviderAggregationCursor, ServiceProviderRunCommandCursor } from '@mongosh/service-provider-core';
import { asPrintable } from './enums';
import { CursorIterationResult } from './result';
export declare abstract class AbstractCursor<CursorType extends ServiceProviderAggregationCursor | ServiceProviderFindCursor | ServiceProviderRunCommandCursor> extends ShellApiWithMongoClass {
    _mongo: Mongo;
    _cursor: CursorType;
    _transform: ((doc: any) => any) | null;
    _currentIterationResult: CursorIterationResult | null;
    constructor(mongo: Mongo, cursor: CursorType);
    [asPrintable](): Promise<CursorIterationResult>;
    _it(): Promise<CursorIterationResult>;
    batchSize(size: number): this;
    close(): Promise<void>;
    forEach(f: (doc: Document) => void | boolean | Promise<void> | Promise<boolean>): Promise<void>;
    hasNext(): Promise<boolean>;
    tryNext(): Promise<Document | null>;
    _tryNext(): Promise<Document | null>;
    _canDelegateIterationToUnderlyingCursor(): boolean;
    [Symbol.asyncIterator](): AsyncGenerator<Document, void, void>;
    isClosed(): boolean;
    isExhausted(): boolean;
    itcount(): Promise<number>;
    toArray(): Promise<Document[]>;
    pretty(): this;
    map(f: (doc: Document) => Document): this;
    maxTimeMS(value: number): this;
    next(): Promise<Document | null>;
    objsLeftInBatch(): number;
}
