import { ShellApiWithMongoClass } from './decorators';
import type { ServiceProviderChangeStream, Document, ResumeToken } from '@mongosh/service-provider-core';
import { CursorIterationResult } from './result';
import { asPrintable } from './enums';
import type Mongo from './mongo';
export default class ChangeStreamCursor extends ShellApiWithMongoClass {
    _mongo: Mongo;
    _cursor: ServiceProviderChangeStream<Document>;
    _currentIterationResult: CursorIterationResult | null;
    _on: string;
    constructor(cursor: ServiceProviderChangeStream<Document>, on: string, mongo: Mongo);
    _it(): Promise<CursorIterationResult>;
    [asPrintable](): string;
    close(): Promise<void>;
    hasNext(): Promise<boolean>;
    tryNext(): Promise<Document | null>;
    [Symbol.asyncIterator](): AsyncGenerator<Document, void, unknown>;
    isClosed(): boolean;
    isExhausted(): never;
    itcount(): Promise<number>;
    next(): Promise<Document>;
    getResumeToken(): ResumeToken;
    map(): ChangeStreamCursor;
    forEach(): Promise<void>;
    toArray(): Promise<Document[]>;
    objsLeftInBatch(): void;
    pretty(): ChangeStreamCursor;
}
