import type { Document } from 'bson';
import { ShellApiWithMongoClass } from './decorators';
import StreamProcessor from './stream-processor';
import { asPrintable } from './enums';
import type Database from './database';
import type Mongo from './mongo';
export declare class Streams extends ShellApiWithMongoClass {
    static newInstance(database: Database): Streams;
    private _database;
    constructor(database: Database);
    get _mongo(): Mongo;
    [asPrintable](): string;
    getProcessor(name: string): StreamProcessor;
    process(pipeline: Document[], options?: Document): Promise<void | Document>;
    createStreamProcessor(name: string, pipeline: Document[], options?: Document): Promise<Document | StreamProcessor>;
    listStreamProcessors(filter: Document): Promise<any>;
    listConnections(filter: Document): Promise<any>;
    _runStreamCommand(cmd: Document, options?: Document): Promise<Document>;
}
