"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.redact = redact;
const lodash_1 = __importDefault(require("lodash"));
const regexes_1 = require("./regexes");
function redact(message) {
    if (lodash_1.default.isPlainObject(message)) {
        return lodash_1.default.mapValues(message, redact);
    }
    if (lodash_1.default.isArray(message)) {
        return lodash_1.default.map(message, redact);
    }
    if (typeof message !== 'string') {
        return message;
    }
    for (const [regex, replacement] of regexes_1.regexes) {
        message = message.replace(regex, replacement);
    }
    return message;
}
exports.default = redact;
//# sourceMappingURL=index.js.map